#include <iostream>
using namespace std;

const long long mod = 1000000007;

struct matrix{
    long long el[2][2];
    matrix operator * (matrix other){
        matrix ans;
        for (int i=0; i<2; ++i){
            for (int j=0; j<2; ++j){
                ans.el[i][j]=0;
                for (int k=0; k<2; ++k){
                    ans.el[i][j] += (el[i][k]*other.el[k][j])%mod + mod;
                    ans.el[i][j] %= mod;
                }
            }
        }
        return ans;
    }
};

long long n;

matrix mpow(matrix a, long long p){
    if (p==1){return a;}
    matrix ans = mpow(a,p/2);
    ans = ans*ans;
    if (p%2){ans = ans*a;}
    return ans;
}
int main(){
    cin>>n;
    matrix step;
    step.el[0][0] = 4;
    step.el[0][1] = -2;
    step.el[1][0] = 1;
    step.el[1][1] = 0;

    step = mpow(step, n);

    cout<<((step.el[1][0]+step.el[1][1])%mod+mod)%mod<<endl;
    return 0;
}
